package mki.xml2csv.access;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import mki.xml2csv.access.DomAccess;
import mki.xml2csv.access.NeoCoreAccess;

import mki.xml2csv.model.Xml2CsvConfigModel;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import com.neocore.httpclient.NeoConnection;

/**
 * NeoCoreɊi[Ă`ɃANZX邽߂̃NXiNeoCoreAccesspĂj
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvNeoCoreAccess
    extends NeoCoreAccess {
  //private NeoConnection neo = null;
  //private String sessionId = null;
  /**
   * RXgN^
   * @throws Exception
   */
  /*public Xml2CsvNeoCoreAccess() throws Exception {
      this("localhost", 7700, "Administrator", "admin");
       }*/
  /**
   * RXgN^
   * @param host
   * @param port
   * @param userid
   * @param password
   * @throws Exception
   */
  public Xml2CsvNeoCoreAccess(
      String host,
      int port,
      String userid,
      String password) throws Exception {
    super(host, port, userid, password);
    /*try {
        //NeoCoreT[oɃOC
        if (neo == null) {
            neo = new NeoConnection(host, port);
            sessionId = neo.login(userid, password);
        }
             } catch (Exception e) {
        System.out.println("NeoCoreւ̐ڑɎs܂B");
        System.out.println("e = " + e);
        throw e;
             }*/
  }

  /**
   * RXgN^
   * @param neo
   * @param sessionId
   */
  public Xml2CsvNeoCoreAccess(NeoConnection neo, String sessionId) {
    super(neo, sessionId);

    //this.neo = neo;
    //this.sessionId = sessionId;
  }

  /**
   * `ID̈ꗗ擾
   *
   * @return `ID̈ꗗiStringListj
   */
  public List getConfigIdList() {
    List lst = new ArrayList();
    try {
      //NeoCoreXMLf[^擾
      String result =
          neo.queryXML(sessionId, "/ND/xml2csv/config/@id/text()");
      //System.out.println("result = " + result);
      DomAccess dom = new DomAccess();
      Document doc = dom.parseString(result,"UTF-8");
      //[ghLgGg擾
      Element element = doc.getDocumentElement();
      String str = element.getChildNodes().item(0).getNodeValue();
      //System.out.println("---" + str + "---");
      StringTokenizer st = new StringTokenizer(str.trim(), "\n");
      String[] ary = new String[st.countTokens()];
      int a = 0;
      while (st.hasMoreTokens()) {
        String val = st.nextToken();
        ary[a] = val;
        a++;
        //lst.add(val);
        //System.out.println("---" + val + "---");
      }
      String tmp = "";
      for (int i = 0; i < ary.length - 1; i++) {
        for (int j = ary.length - 1; j > i; j--) {
          if (ary[j].compareTo(ary[j - 1]) < 0) {
            tmp = ary[j];
            ary[j] = ary[j - 1];
            ary[j - 1] = tmp;
          }
        }
      }
      for (int k = 0; k < ary.length; k++) {
        System.out.println("---" + ary[k] + "---");
        lst.add(ary[k]);
      }
    }
    catch (Exception e) {
      System.out.println("e = " + e);
    }
    return lst;
  }

  /**
   * `IDƔl̈ꗗ擾B
   *
   * @return `IDƔl̈ꗗiStringzListBString[0]`IDAString[1]lj
   */
  public List getConfigIdMemoList() {
    List lst = new ArrayList();
    try {
      StringBuffer sb = new StringBuffer();
      sb.append("for $c in /ND/xml2csv/config ");
      sb.append("return <data>{$c/@id}{$c/memo}</data> ");
      sb.append("sortby (@id)");

      //System.out.println("query = " + sb.toString());
      //NeoCoreXMLf[^擾
      String result = neo.queryXML(sessionId, sb.toString());
      //System.out.println("result = " + result);
      DomAccess dom = new DomAccess();
      Document doc = dom.parseString(result, "UTF-8");
      //[ghLgGg擾
      Element element = doc.getDocumentElement();

      //tB[h
      NodeList lstData = element.getElementsByTagName("data");
      //System.out.println("csvfile3 = " + csvfile);
      int numData = lstData.getLength();
      for (int m = 0; m < numData; m++) {
        Element elmData = (Element) lstData.item(m);
        String[] data = new String[2];
        //data[0] = getTagValue(elmData, "config");
        NodeList lstNode = elmData.getElementsByTagName("config");
        Element elm = (Element) lstNode.item(0);
        data[0] = elm.getAttribute("id");
        try {
          lstNode = elmData.getElementsByTagName("memo");
          elm = (Element) lstNode.item(0);
          data[1] = elm.getChildNodes().item(0).getNodeValue();
        }
        catch (Exception ex) {
          data[1] = "";
        }
        lst.add(data);
      }
    }
    catch (Exception e) {
      System.out.println("e = " + e);
    }
    return lst;
  }

  /**
   * w肳ꂽ`ID̒`擾Ē`񃂃fNXɊi[ĕԂ
   *
   * @param id `ID
   * @param enc encoding
   * @throws Exception
   * @return Xml2CsvConfigModel
   */
  public Xml2CsvConfigModel getConfigModel(String id, String enc) throws
      Exception {
    Xml2CsvConfigModel model = null;
    try {
      //NeoCoreXMLf[^擾
      String query = getConfigQuery(id);
      //String query = "/ND/xml2csv[@id=\"" + id + "\"]";
      //System.out.println("query = " + query);
      String result = neo.queryXML(sessionId, query);
      //System.out.println("result = " + result);

      Xml2CsvConfigXmlParse parser = new Xml2CsvConfigXmlParse();
      model = parser.parseString(result, enc);
    }
    catch (Exception e) {
      model = null;
      System.out.println("getConfigModelG[ = " + e);
      throw e;
    }
    return model;
  }

  /**
   * R[h^O̐΃pX擾B
   *
   * @param query NG
   * @return String
   */
  public String getRecordTagPath(String query) {
    return query + getRecordTag(query);
  }

  /**
   * R[h^O擾B
   *
   * @param query NG
   * @return String
   */
  private String getRecordTag(String query) {
    String rec = "";
    String qry = "";
    int count = 0;
    //R[h^O擾
    try {
      int cnt0 = 0;
      int lastindex = 0;
      int index = 0;
      String str2 = "";
      while (query.lastIndexOf("[") != -1 && cnt0 < 100) {
        lastindex = query.lastIndexOf("[");
        index = query.indexOf("]", lastindex);
        str2 =
            query.substring(0, lastindex) + query.substring(index + 1);
        //System.out.println(str2);
        query = str2;
        cnt0++;
      }
      lastindex = query.lastIndexOf("/");
      str2 = query.substring(lastindex + 1);
      //System.out.println(str2);
      if (str2.startsWith("@")) {
        query = query.substring(0, lastindex);
        //System.out.println(query);
      }
      //lastindex = query.lastIndexOf("/");
      //String query2 = query.substring(lastindex);
      //System.out.println(query2);
      //System.out.println("query" + query);

      DomAccess dom = new DomAccess();
      //NeoCoreXMLf[^\擾
      while (true) {
        String result = neo.queryTreeXML(sessionId, query);
        Document doc = dom.parseString(result,"UTF-8");
        //[ghLgGg擾
        Element element = doc.getDocumentElement();
        //System.out.println("name = " + element2.getTagName());
        //System.out.println("val = " + element2.getNodeValue());
        result = element.getChildNodes().item(0).getNodeValue().trim();
        StringTokenizer st = new StringTokenizer(result, ",");
        int cnt = 0;
        String rectag = "";
        while (st.hasMoreTokens()) {
          String val = st.nextToken();
          if (!val.startsWith("@")) {
            cnt++;
            rectag = val;
          }
        }
        if (cnt == 1 && count < 100) {
          query = query + "/" + rectag;
          rec = rec + "/" + rectag;
        }
        else {
          break;
        }
        count++;
      }
    }
    catch (Exception e) {
      //System.out.println("e = " + e);
      //throw e;
    }
    return rec;
  }

  /**
   * w肳ꂽ`ID̒`COUNT擾
   *
   * @param id `ID
   * @return `񂪑݂Ă1,݂ĂȂ0
   */
  public int queryConfigCountXML(String id) {
    int count = 0;
    try {
      String query = getConfigQuery(id);
      count = queryCountXML(query);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
    }
    return count;
  }

  /**
   * w肳ꂽ`ID̒`w肳ꂽString̒`ōXVB`̍\ςĂꍇ̓G[ƂȂ
   *
   * @param id `ID
   * @param modfyXml `
   * @return String
   */
  public String modifyConfigXML(String id, String modfyXml) {
    String str = null;
    String query = getConfigQuery(id);
    try {
      str = neo.modifyXML(sessionId, query, modfyXml);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
    }
    return str;
  }

  /**
   * w肳ꂽ`ID̒`폜
   *
   * @param id `ID
   * @param modfyXml `
   * @return String
   */
  public String deleteConfigXML(String id) {
    String str = null;
    String query = getConfigQuery(id);
    try {
      str = neo.deleteXML(sessionId, query);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
    }
    return str;
  }

  /**
   * w肳ꂽ`ID̒`擾邽߂XPathԂ
   *
   * @param id `ID
   * @return String
   */
  private String getConfigQuery(String id) {
    return "/ND/xml2csv/config[@id=\"" + id + "\"]";
  }

  /*public void close() {
    //NeoCoreT[o烍OAEg
    try {
      if (sessionId != null) {
        neo.logout(sessionId);
      }
    }
    catch (Exception ex) {
      System.out.println("e = " + ex);
      //throw e;
    }
  }

  protected void finalize() throws Throwable {
    //close();
  }*/
}
